<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>NIOServerCnxn.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">NIOServerCnxn.java</span></div><h1>NIOServerCnxn.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import java.io.BufferedWriter;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Writer;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.nio.ByteBuffer;
import java.nio.channels.CancelledKeyException;
import java.nio.channels.SelectionKey;
import java.nio.channels.SocketChannel;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.concurrent.LinkedBlockingQueue;

import org.apache.jute.BinaryInputArchive;
import org.apache.jute.BinaryOutputArchive;
import org.apache.jute.Record;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.Environment;
import org.apache.zookeeper.Version;
import org.apache.zookeeper.WatchedEvent;
import org.apache.zookeeper.data.Id;
import org.apache.zookeeper.proto.ReplyHeader;
import org.apache.zookeeper.proto.RequestHeader;
import org.apache.zookeeper.proto.WatcherEvent;
import org.apache.zookeeper.server.quorum.Leader;
import org.apache.zookeeper.server.quorum.LeaderZooKeeperServer;
import org.apache.zookeeper.server.quorum.ReadOnlyZooKeeperServer;
import org.apache.zookeeper.server.util.OSMXBean;

/**
 * This class handles communication with clients using NIO. There is one per
 * client, but only one thread doing the communication.
 */
public class NIOServerCnxn extends ServerCnxn {
<span class="fc" id="L59">    static final Logger LOG = LoggerFactory.getLogger(NIOServerCnxn.class);</span>

    NIOServerCnxnFactory factory;

    final SocketChannel sock;

    private final SelectionKey sk;

    boolean initialized;

<span class="fc" id="L69">    ByteBuffer lenBuffer = ByteBuffer.allocate(4);</span>

<span class="fc" id="L71">    ByteBuffer incomingBuffer = lenBuffer;</span>

<span class="fc" id="L73">    LinkedBlockingQueue&lt;ByteBuffer&gt; outgoingBuffers = new LinkedBlockingQueue&lt;ByteBuffer&gt;();</span>

    int sessionTimeout;

    private final ZooKeeperServer zkServer;

    /**
     * The number of requests that have been submitted but not yet responded to.
     */
    int outstandingRequests;

    /**
     * This is the id that uniquely identifies the session of a client. Once
     * this session is no longer active, the ephemeral nodes will go away.
     */
    long sessionId;

<span class="fc" id="L90">    static long nextSessionId = 1;</span>
<span class="fc" id="L91">    int outstandingLimit = 1;</span>

    public NIOServerCnxn(ZooKeeperServer zk, SocketChannel sock,
<span class="fc" id="L94">            SelectionKey sk, NIOServerCnxnFactory factory) throws IOException {</span>
<span class="fc" id="L95">        this.zkServer = zk;</span>
<span class="fc" id="L96">        this.sock = sock;</span>
<span class="fc" id="L97">        this.sk = sk;</span>
<span class="fc" id="L98">        this.factory = factory;</span>
<span class="fc bfc" id="L99" title="All 2 branches covered.">        if (this.factory.login != null) {</span>
<span class="fc" id="L100">            this.zooKeeperSaslServer = new ZooKeeperSaslServer(factory.login);</span>
        }
<span class="fc bfc" id="L102" title="All 2 branches covered.">        if (zk != null) { </span>
<span class="fc" id="L103">            outstandingLimit = zk.getGlobalOutstandingLimit();</span>
        }
<span class="fc" id="L105">        sock.socket().setTcpNoDelay(true);</span>
        /* set socket linger to false, so that socket close does not
         * block */
<span class="fc" id="L108">        sock.socket().setSoLinger(false, -1);</span>
<span class="fc" id="L109">        InetAddress addr = ((InetSocketAddress) sock.socket()</span>
<span class="fc" id="L110">                .getRemoteSocketAddress()).getAddress();</span>
<span class="fc" id="L111">        authInfo.add(new Id(&quot;ip&quot;, addr.getHostAddress()));</span>
<span class="fc" id="L112">        sk.interestOps(SelectionKey.OP_READ);</span>
<span class="fc" id="L113">    }</span>

    /* Send close connection packet to the client, doIO will eventually
     * close the underlying machinery (like socket, selectorkey, etc...)
     */
    public void sendCloseSession() {
<span class="fc" id="L119">        sendBuffer(ServerCnxnFactory.closeConn);</span>
<span class="fc" id="L120">    }</span>

    /**
     * send buffer without using the asynchronous
     * calls to selector and then close the socket
     * @param bb
     */
    void sendBufferSync(ByteBuffer bb) {
       try {
           /* configure socket to be blocking
            * so that we dont have to do write in 
            * a tight while loop
            */
<span class="fc" id="L133">           sock.configureBlocking(true);</span>
<span class="pc bpc" id="L134" title="1 of 2 branches missed.">           if (bb != ServerCnxnFactory.closeConn) {</span>
<span class="pc bpc" id="L135" title="1 of 2 branches missed.">               if (sock.isOpen()) {</span>
<span class="fc" id="L136">                   sock.write(bb);</span>
               }
<span class="fc" id="L138">               packetSent();</span>
           } 
<span class="fc" id="L140">       } catch (IOException ie) {</span>
<span class="fc" id="L141">           LOG.error(&quot;Error sending data synchronously &quot;, ie);</span>
<span class="fc" id="L142">       }</span>
<span class="fc" id="L143">    }</span>
    
    public void sendBuffer(ByteBuffer bb) {
        try {
<span class="fc bfc" id="L147" title="All 2 branches covered.">            if (bb != ServerCnxnFactory.closeConn) {</span>
                // We check if write interest here because if it is NOT set,
                // nothing is queued, so we can try to send the buffer right
                // away without waking up the selector
<span class="pc bpc" id="L151" title="1 of 2 branches missed.">                if ((sk.interestOps() &amp; SelectionKey.OP_WRITE) == 0) {</span>
                    try {
<span class="fc" id="L153">                        sock.write(bb);</span>
<span class="fc" id="L154">                    } catch (IOException e) {</span>
                        // we are just doing best effort right now
<span class="fc" id="L156">                    }</span>
                }
                // if there is nothing left to send, we are done
<span class="fc bfc" id="L159" title="All 2 branches covered.">                if (bb.remaining() == 0) {</span>
<span class="fc" id="L160">                    packetSent();</span>
<span class="fc" id="L161">                    return;</span>
                }
            }

<span class="fc" id="L165">            synchronized(this.factory){</span>
<span class="fc" id="L166">                sk.selector().wakeup();</span>
<span class="pc bpc" id="L167" title="1 of 2 branches missed.">                if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L168">                    LOG.trace(&quot;Add a buffer to outgoingBuffers, sk &quot; + sk</span>
<span class="nc" id="L169">                            + &quot; is valid: &quot; + sk.isValid());</span>
                }
<span class="fc" id="L171">                outgoingBuffers.add(bb);</span>
<span class="fc bfc" id="L172" title="All 2 branches covered.">                if (sk.isValid()) {</span>
<span class="fc" id="L173">                    sk.interestOps(sk.interestOps() | SelectionKey.OP_WRITE);</span>
                }
<span class="pc" id="L175">            }</span>
            
<span class="fc" id="L177">        } catch(Exception e) {</span>
<span class="fc" id="L178">            LOG.error(&quot;Unexpected Exception: &quot;, e);</span>
<span class="fc" id="L179">        }</span>
<span class="fc" id="L180">    }</span>

    /** Read the request payload (everything following the length prefix) */
    private void readPayload() throws IOException, InterruptedException {
<span class="fc bfc" id="L184" title="All 2 branches covered.">        if (incomingBuffer.remaining() != 0) { // have we read length bytes?</span>
<span class="fc" id="L185">            int rc = sock.read(incomingBuffer); // sock is non-blocking, so ok</span>
<span class="pc bpc" id="L186" title="1 of 2 branches missed.">            if (rc &lt; 0) {</span>
<span class="nc" id="L187">                throw new EndOfStreamException(</span>
                        &quot;Unable to read additional data from client sessionid 0x&quot;
<span class="nc" id="L189">                        + Long.toHexString(sessionId)</span>
                        + &quot;, likely client has closed socket&quot;);
            }
        }

<span class="fc bfc" id="L194" title="All 2 branches covered.">        if (incomingBuffer.remaining() == 0) { // have we read length bytes?</span>
<span class="fc" id="L195">            packetReceived();</span>
<span class="fc" id="L196">            incomingBuffer.flip();</span>
<span class="fc bfc" id="L197" title="All 2 branches covered.">            if (!initialized) {</span>
<span class="fc" id="L198">                readConnectRequest();</span>
            } else {
<span class="fc" id="L200">                readRequest();</span>
            }
<span class="fc" id="L202">            lenBuffer.clear();</span>
<span class="fc" id="L203">            incomingBuffer = lenBuffer;</span>
        }
<span class="fc" id="L205">    }</span>

    /**
     * Only used in order to allow testing
     */
    protected boolean isSocketOpen() {
<span class="fc" id="L211">        return sock.isOpen();</span>
    }

    /**
     * Handles read/write IO on connection.
     */
    void doIO(SelectionKey k) throws InterruptedException {
        try {
<span class="pc bpc" id="L219" title="1 of 2 branches missed.">            if (isSocketOpen() == false) {</span>
<span class="nc" id="L220">                LOG.warn(&quot;trying to do i/o on a null socket for session:0x&quot;</span>
<span class="nc" id="L221">                         + Long.toHexString(sessionId));</span>

<span class="nc" id="L223">                return;</span>
            }
<span class="fc bfc" id="L225" title="All 2 branches covered.">            if (k.isReadable()) {</span>
<span class="fc" id="L226">                int rc = sock.read(incomingBuffer);</span>
<span class="fc bfc" id="L227" title="All 2 branches covered.">                if (rc &lt; 0) {</span>
<span class="fc" id="L228">                    throw new EndOfStreamException(</span>
                            &quot;Unable to read additional data from client sessionid 0x&quot;
<span class="fc" id="L230">                            + Long.toHexString(sessionId)</span>
                            + &quot;, likely client has closed socket&quot;);
                }
<span class="pc bpc" id="L233" title="1 of 2 branches missed.">                if (incomingBuffer.remaining() == 0) {</span>
                    boolean isPayload;
<span class="fc bfc" id="L235" title="All 2 branches covered.">                    if (incomingBuffer == lenBuffer) { // start of next request</span>
<span class="fc" id="L236">                        incomingBuffer.flip();</span>
<span class="fc" id="L237">                        isPayload = readLength(k);</span>
<span class="fc" id="L238">                        incomingBuffer.clear();</span>
                    } else {
                        // continuation
<span class="fc" id="L241">                        isPayload = true;</span>
                    }
<span class="fc bfc" id="L243" title="All 2 branches covered.">                    if (isPayload) { // not the case for 4letterword</span>
<span class="fc" id="L244">                        readPayload();</span>
                    }
                    else {
                        // four letter words take care
                        // need not do anything else
<span class="fc" id="L249">                        return;</span>
                    }
                }
            }
<span class="fc bfc" id="L253" title="All 2 branches covered.">            if (k.isWritable()) {</span>
                // ZooLog.logTraceMessage(LOG,
                // ZooLog.CLIENT_DATA_PACKET_TRACE_MASK
                // &quot;outgoingBuffers.size() = &quot; +
                // outgoingBuffers.size());
<span class="pc bpc" id="L258" title="1 of 2 branches missed.">                if (outgoingBuffers.size() &gt; 0) {</span>
                    // ZooLog.logTraceMessage(LOG,
                    // ZooLog.CLIENT_DATA_PACKET_TRACE_MASK,
                    // &quot;sk &quot; + k + &quot; is valid: &quot; +
                    // k.isValid());

                    /*
                     * This is going to reset the buffer position to 0 and the
                     * limit to the size of the buffer, so that we can fill it
                     * with data from the non-direct buffers that we need to
                     * send.
                     */
<span class="fc" id="L270">                    ByteBuffer directBuffer = factory.directBuffer;</span>
<span class="fc" id="L271">                    directBuffer.clear();</span>

<span class="fc bfc" id="L273" title="All 2 branches covered.">                    for (ByteBuffer b : outgoingBuffers) {</span>
<span class="pc bpc" id="L274" title="1 of 2 branches missed.">                        if (directBuffer.remaining() &lt; b.remaining()) {</span>
                            /*
                             * When we call put later, if the directBuffer is to
                             * small to hold everything, nothing will be copied,
                             * so we've got to slice the buffer if it's too big.
                             */
<span class="nc" id="L280">                            b = (ByteBuffer) b.slice().limit(</span>
<span class="nc" id="L281">                                    directBuffer.remaining());</span>
                        }
                        /*
                         * put() is going to modify the positions of both
                         * buffers, put we don't want to change the position of
                         * the source buffers (we'll do that after the send, if
                         * needed), so we save and reset the position after the
                         * copy
                         */
<span class="fc" id="L290">                        int p = b.position();</span>
<span class="fc" id="L291">                        directBuffer.put(b);</span>
<span class="fc" id="L292">                        b.position(p);</span>
<span class="pc bpc" id="L293" title="1 of 2 branches missed.">                        if (directBuffer.remaining() == 0) {</span>
<span class="nc" id="L294">                            break;</span>
                        }
<span class="fc" id="L296">                    }</span>
                    /*
                     * Do the flip: limit becomes position, position gets set to
                     * 0. This sets us up for the write.
                     */
<span class="fc" id="L301">                    directBuffer.flip();</span>

<span class="fc" id="L303">                    int sent = sock.write(directBuffer);</span>
                    ByteBuffer bb;

                    // Remove the buffers that we have sent
<span class="pc bpc" id="L307" title="1 of 2 branches missed.">                    while (outgoingBuffers.size() &gt; 0) {</span>
<span class="fc" id="L308">                        bb = outgoingBuffers.peek();</span>
<span class="fc bfc" id="L309" title="All 2 branches covered.">                        if (bb == ServerCnxnFactory.closeConn) {</span>
<span class="fc" id="L310">                            throw new CloseRequestException(&quot;close requested&quot;);</span>
                        }
<span class="fc" id="L312">                        int left = bb.remaining() - sent;</span>
<span class="pc bpc" id="L313" title="1 of 2 branches missed.">                        if (left &gt; 0) {</span>
                            /*
                             * We only partially sent this buffer, so we update
                             * the position and exit the loop.
                             */
<span class="fc" id="L318">                            bb.position(bb.position() + sent);</span>
<span class="fc" id="L319">                            break;</span>
                        }
<span class="nc" id="L321">                        packetSent();</span>
                        /* We've sent the whole buffer, so drop the buffer */
<span class="nc" id="L323">                        sent -= bb.remaining();</span>
<span class="nc" id="L324">                        outgoingBuffers.remove();</span>
<span class="nc" id="L325">                    }</span>
                    // ZooLog.logTraceMessage(LOG,
                    // ZooLog.CLIENT_DATA_PACKET_TRACE_MASK, &quot;after send,
                    // outgoingBuffers.size() = &quot; + outgoingBuffers.size());
                }

<span class="fc" id="L331">                synchronized(this.factory){</span>
<span class="pc bpc" id="L332" title="1 of 2 branches missed.">                    if (outgoingBuffers.size() == 0) {</span>
<span class="nc bnc" id="L333" title="All 2 branches missed.">                        if (!initialized</span>
<span class="nc bnc" id="L334" title="All 2 branches missed.">                                &amp;&amp; (sk.interestOps() &amp; SelectionKey.OP_READ) == 0) {</span>
<span class="nc" id="L335">                            throw new CloseRequestException(&quot;responded to info probe&quot;);</span>
                        }
<span class="nc" id="L337">                        sk.interestOps(sk.interestOps()</span>
                                &amp; (~SelectionKey.OP_WRITE));
                    } else {
<span class="fc" id="L340">                        sk.interestOps(sk.interestOps()</span>
                                | SelectionKey.OP_WRITE);
                    }
<span class="pc" id="L343">                }</span>
            }
<span class="fc" id="L345">        } catch (CancelledKeyException e) {</span>
<span class="fc" id="L346">            LOG.warn(&quot;Exception causing close of session 0x&quot;</span>
<span class="fc" id="L347">                    + Long.toHexString(sessionId)</span>
                    + &quot; due to &quot; + e);
<span class="pc bpc" id="L349" title="1 of 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L350">                LOG.debug(&quot;CancelledKeyException stack trace&quot;, e);</span>
            }
<span class="fc" id="L352">            close();</span>
<span class="fc" id="L353">        } catch (CloseRequestException e) {</span>
            // expecting close to log session closure
<span class="fc" id="L355">            close();</span>
<span class="fc" id="L356">        } catch (EndOfStreamException e) {</span>
<span class="fc" id="L357">            LOG.warn(&quot;caught end of stream exception&quot;,e); // tell user why</span>

            // expecting close to log session closure
<span class="fc" id="L360">            close();</span>
<span class="fc" id="L361">        } catch (IOException e) {</span>
<span class="fc" id="L362">            LOG.warn(&quot;Exception causing close of session 0x&quot;</span>
<span class="fc" id="L363">                    + Long.toHexString(sessionId)</span>
                    + &quot; due to &quot; + e);
<span class="pc bpc" id="L365" title="1 of 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L366">                LOG.debug(&quot;IOException stack trace&quot;, e);</span>
            }
<span class="fc" id="L368">            close();</span>
<span class="fc" id="L369">        }</span>
<span class="fc" id="L370">    }</span>

    private void readRequest() throws IOException {
<span class="fc" id="L373">        zkServer.processPacket(this, incomingBuffer);</span>
<span class="fc" id="L374">    }</span>
    
    protected void incrOutstandingRequests(RequestHeader h) {
<span class="fc bfc" id="L377" title="All 2 branches covered.">        if (h.getXid() &gt;= 0) {</span>
<span class="fc" id="L378">            synchronized (this) {</span>
<span class="fc" id="L379">                outstandingRequests++;</span>
<span class="pc" id="L380">            }</span>
<span class="fc" id="L381">            synchronized (this.factory) {        </span>
                // check throttling
<span class="fc bfc" id="L383" title="All 2 branches covered.">                if (zkServer.getInProcess() &gt; outstandingLimit) {</span>
<span class="pc bpc" id="L384" title="1 of 2 branches missed.">                    if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L385">                        LOG.debug(&quot;Throttling recv &quot; + zkServer.getInProcess());</span>
                    }
<span class="fc" id="L387">                    disableRecv();</span>
                    // following lines should not be needed since we are
                    // already reading
                    // } else {
                    // enableRecv();
                }
<span class="pc" id="L393">            }</span>
        }

<span class="fc" id="L396">    }</span>

    public void disableRecv() {
<span class="fc" id="L399">        sk.interestOps(sk.interestOps() &amp; (~SelectionKey.OP_READ));</span>
<span class="fc" id="L400">    }</span>

    public void enableRecv() {
<span class="fc" id="L403">        synchronized (this.factory) {</span>
<span class="fc" id="L404">            sk.selector().wakeup();</span>
<span class="fc bfc" id="L405" title="All 2 branches covered.">            if (sk.isValid()) {</span>
<span class="fc" id="L406">                int interest = sk.interestOps();</span>
<span class="fc bfc" id="L407" title="All 2 branches covered.">                if ((interest &amp; SelectionKey.OP_READ) == 0) {</span>
<span class="fc" id="L408">                    sk.interestOps(interest | SelectionKey.OP_READ);</span>
                }
            }
<span class="pc" id="L411">        }</span>
<span class="fc" id="L412">    }</span>

    private void readConnectRequest() throws IOException, InterruptedException {
<span class="pc bpc" id="L415" title="1 of 2 branches missed.">        if (zkServer == null) {</span>
<span class="nc" id="L416">            throw new IOException(&quot;ZooKeeperServer not running&quot;);</span>
        }
<span class="fc" id="L418">        zkServer.processConnectRequest(this, incomingBuffer);</span>
<span class="fc" id="L419">        initialized = true;</span>
<span class="fc" id="L420">    }</span>

    /**
     * clean up the socket related to a command and also make sure we flush the
     * data before we do that
     * 
     * @param pwriter
     *            the pwriter for a command socket
     */
    private void cleanupWriterSocket(PrintWriter pwriter) {
        try {
<span class="pc bpc" id="L431" title="1 of 2 branches missed.">            if (pwriter != null) {</span>
<span class="fc" id="L432">                pwriter.flush();</span>
<span class="fc" id="L433">                pwriter.close();</span>
            }
<span class="pc" id="L435">        } catch (Exception e) {</span>
<span class="nc" id="L436">            LOG.info(&quot;Error closing PrintWriter &quot;, e);</span>
<span class="nc" id="L437">        } finally {</span>
<span class="nc" id="L438">            try {</span>
<span class="pc" id="L439">                close();</span>
<span class="nc" id="L440">            } catch (Exception e) {</span>
<span class="nc" id="L441">                LOG.error(&quot;Error closing a command socket &quot;, e);</span>
<span class="pc" id="L442">            }</span>
<span class="pc" id="L443">        }</span>
<span class="fc" id="L444">    }</span>
    
    /**
     * This class wraps the sendBuffer method of NIOServerCnxn. It is
     * responsible for chunking up the response to a client. Rather
     * than cons'ing up a response fully in memory, which may be large
     * for some commands, this class chunks up the result.
     */
<span class="fc" id="L452">    private class SendBufferWriter extends Writer {</span>
<span class="fc" id="L453">        private StringBuffer sb = new StringBuffer();</span>
        
        /**
         * Check if we are ready to send another chunk.
         * @param force force sending, even if not a full chunk
         */
        private void checkFlush(boolean force) {
<span class="fc bfc" id="L460" title="All 6 branches covered.">            if ((force &amp;&amp; sb.length() &gt; 0) || sb.length() &gt; 2048) {</span>
<span class="fc" id="L461">                sendBufferSync(ByteBuffer.wrap(sb.toString().getBytes()));</span>
                // clear our internal buffer
<span class="fc" id="L463">                sb.setLength(0);</span>
            }
<span class="fc" id="L465">        }</span>

        @Override
        public void close() throws IOException {
<span class="pc bpc" id="L469" title="1 of 2 branches missed.">            if (sb == null) return;</span>
<span class="fc" id="L470">            checkFlush(true);</span>
<span class="fc" id="L471">            sb = null; // clear out the ref to ensure no reuse</span>
<span class="fc" id="L472">        }</span>

        @Override
        public void flush() throws IOException {
<span class="fc" id="L476">            checkFlush(true);</span>
<span class="fc" id="L477">        }</span>

        @Override
        public void write(char[] cbuf, int off, int len) throws IOException {
<span class="fc" id="L481">            sb.append(cbuf, off, len);</span>
<span class="fc" id="L482">            checkFlush(false);</span>
<span class="fc" id="L483">        }</span>
    }

    private static final String ZK_NOT_SERVING =
        &quot;This ZooKeeper instance is not currently serving requests&quot;;
    
    /**
     * Set of threads for commmand ports. All the 4
     * letter commands are run via a thread. Each class
     * maps to a corresponding 4 letter command. CommandThread
     * is the abstract class from which all the others inherit.
     */
    private abstract class CommandThread extends Thread {
        PrintWriter pw;
        
<span class="fc" id="L498">        CommandThread(PrintWriter pw) {</span>
<span class="fc" id="L499">            this.pw = pw;</span>
<span class="fc" id="L500">        }</span>
        
        public void run() {
            try {
<span class="fc" id="L504">                commandRun();</span>
<span class="pc" id="L505">            } catch (IOException ie) {</span>
<span class="nc" id="L506">                LOG.error(&quot;Error in running command &quot;, ie);</span>
<span class="nc" id="L507">            } finally {</span>
<span class="nc" id="L508">                cleanupWriterSocket(pw);</span>
<span class="pc" id="L509">            }</span>
<span class="pc" id="L510">        }</span>
        
        public abstract void commandRun() throws IOException;
    }
    
    private class RuokCommand extends CommandThread {
<span class="fc" id="L516">        public RuokCommand(PrintWriter pw) {</span>
<span class="fc" id="L517">            super(pw);</span>
<span class="fc" id="L518">        }</span>
        
        @Override
        public void commandRun() {
<span class="fc" id="L522">            pw.print(&quot;imok&quot;);</span>
            
<span class="fc" id="L524">        }</span>
    }
    
    private class TraceMaskCommand extends CommandThread {
<span class="fc" id="L528">        TraceMaskCommand(PrintWriter pw) {</span>
<span class="fc" id="L529">            super(pw);</span>
<span class="fc" id="L530">        }</span>
        
        @Override
        public void commandRun() {
<span class="fc" id="L534">            long traceMask = ZooTrace.getTextTraceLevel();</span>
<span class="fc" id="L535">            pw.print(traceMask);</span>
<span class="fc" id="L536">        }</span>
    }
    
    private class SetTraceMaskCommand extends CommandThread {
<span class="fc" id="L540">        long trace = 0;</span>
<span class="fc" id="L541">        SetTraceMaskCommand(PrintWriter pw, long trace) {</span>
<span class="fc" id="L542">            super(pw);</span>
<span class="fc" id="L543">            this.trace = trace;</span>
<span class="fc" id="L544">        }</span>
        
        @Override
        public void commandRun() {
<span class="fc" id="L548">            pw.print(trace);</span>
<span class="fc" id="L549">        }</span>
    }
    
    private class EnvCommand extends CommandThread {
<span class="fc" id="L553">        EnvCommand(PrintWriter pw) {</span>
<span class="fc" id="L554">            super(pw);</span>
<span class="fc" id="L555">        }</span>
        
        @Override
        public void commandRun() {
<span class="fc" id="L559">            List&lt;Environment.Entry&gt; env = Environment.list();</span>

<span class="fc" id="L561">            pw.println(&quot;Environment:&quot;);</span>
<span class="fc bfc" id="L562" title="All 2 branches covered.">            for(Environment.Entry e : env) {</span>
<span class="fc" id="L563">                pw.print(e.getKey());</span>
<span class="fc" id="L564">                pw.print(&quot;=&quot;);</span>
<span class="fc" id="L565">                pw.println(e.getValue());</span>
<span class="fc" id="L566">            }</span>
            
<span class="fc" id="L568">        } </span>
    }
    
    private class ConfCommand extends CommandThread {
<span class="fc" id="L572">        ConfCommand(PrintWriter pw) {</span>
<span class="fc" id="L573">            super(pw);</span>
<span class="fc" id="L574">        }</span>
            
        @Override
        public void commandRun() {
<span class="pc bpc" id="L578" title="1 of 2 branches missed.">            if (zkServer == null) {</span>
<span class="nc" id="L579">                pw.println(ZK_NOT_SERVING);</span>
            } else {
<span class="fc" id="L581">                zkServer.dumpConf(pw);</span>
            }
<span class="fc" id="L583">        }</span>
    }
    
    private class StatResetCommand extends CommandThread {
<span class="fc" id="L587">        public StatResetCommand(PrintWriter pw) {</span>
<span class="fc" id="L588">            super(pw);</span>
<span class="fc" id="L589">        }</span>
        
        @Override
        public void commandRun() {
<span class="pc bpc" id="L593" title="1 of 2 branches missed.">            if (zkServer == null) {</span>
<span class="nc" id="L594">                pw.println(ZK_NOT_SERVING);</span>
            }
            else { 
<span class="fc" id="L597">                zkServer.serverStats().reset();</span>
<span class="fc" id="L598">                pw.println(&quot;Server stats reset.&quot;);</span>
            }
<span class="fc" id="L600">        }</span>
    }
    
    private class CnxnStatResetCommand extends CommandThread {
<span class="fc" id="L604">        public CnxnStatResetCommand(PrintWriter pw) {</span>
<span class="fc" id="L605">            super(pw);</span>
<span class="fc" id="L606">        }</span>
        
        @Override
        public void commandRun() {
<span class="pc bpc" id="L610" title="1 of 2 branches missed.">            if (zkServer == null) {</span>
<span class="nc" id="L611">                pw.println(ZK_NOT_SERVING);</span>
            } else {
<span class="fc" id="L613">                synchronized(factory.cnxns){</span>
<span class="fc bfc" id="L614" title="All 2 branches covered.">                    for(ServerCnxn c : factory.cnxns){</span>
<span class="fc" id="L615">                        c.resetStats();</span>
<span class="fc" id="L616">                    }</span>
<span class="pc" id="L617">                }</span>
<span class="fc" id="L618">                pw.println(&quot;Connection stats reset.&quot;);</span>
            }
<span class="fc" id="L620">        }</span>
    }

    private class DumpCommand extends CommandThread {
<span class="fc" id="L624">        public DumpCommand(PrintWriter pw) {</span>
<span class="fc" id="L625">            super(pw);</span>
<span class="fc" id="L626">        }</span>
        
        @Override
        public void commandRun() {
<span class="pc bpc" id="L630" title="1 of 2 branches missed.">            if (zkServer == null) {</span>
<span class="nc" id="L631">                pw.println(ZK_NOT_SERVING);</span>
            }
            else {
<span class="fc" id="L634">                pw.println(&quot;SessionTracker dump:&quot;);</span>
<span class="fc" id="L635">                zkServer.sessionTracker.dumpSessions(pw);</span>
<span class="fc" id="L636">                pw.println(&quot;ephemeral nodes dump:&quot;);</span>
<span class="fc" id="L637">                zkServer.dumpEphemerals(pw);</span>
            }
<span class="fc" id="L639">        }</span>
    }
    
    private class StatCommand extends CommandThread {
        int len;
<span class="fc" id="L644">        public StatCommand(PrintWriter pw, int len) {</span>
<span class="fc" id="L645">            super(pw);</span>
<span class="fc" id="L646">            this.len = len;</span>
<span class="fc" id="L647">        }</span>
        
        @SuppressWarnings(&quot;unchecked&quot;)
        @Override
        public void commandRun() {
<span class="fc bfc" id="L652" title="All 2 branches covered.">            if (zkServer == null) {</span>
<span class="fc" id="L653">                pw.println(ZK_NOT_SERVING);</span>
            }
            else {   
<span class="fc" id="L656">                pw.print(&quot;Zookeeper version: &quot;);</span>
<span class="fc" id="L657">                pw.println(Version.getFullVersion());</span>
<span class="fc bfc" id="L658" title="All 2 branches covered.">                if (zkServer instanceof ReadOnlyZooKeeperServer) {</span>
<span class="fc" id="L659">                    pw.println(&quot;READ-ONLY mode; serving only &quot; +</span>
                               &quot;read-only clients&quot;);
                }
<span class="fc bfc" id="L662" title="All 2 branches covered.">                if (len == statCmd) {</span>
<span class="fc" id="L663">                    LOG.info(&quot;Stat command output&quot;);</span>
<span class="fc" id="L664">                    pw.println(&quot;Clients:&quot;);</span>
                    // clone should be faster than iteration
                    // ie give up the cnxns lock faster
                    HashSet&lt;NIOServerCnxn&gt; cnxnset;
<span class="fc" id="L668">                    synchronized(factory.cnxns){</span>
<span class="fc" id="L669">                        cnxnset = (HashSet&lt;NIOServerCnxn&gt;)factory</span>
<span class="fc" id="L670">                        .cnxns.clone();</span>
<span class="pc" id="L671">                    }</span>
<span class="fc bfc" id="L672" title="All 2 branches covered.">                    for(NIOServerCnxn c : cnxnset){</span>
<span class="fc" id="L673">                        c.dumpConnectionInfo(pw, true);</span>
<span class="fc" id="L674">                        pw.println();</span>
<span class="fc" id="L675">                    }</span>
<span class="fc" id="L676">                    pw.println();</span>
                }
<span class="fc" id="L678">                pw.print(zkServer.serverStats().toString());</span>
<span class="fc" id="L679">                pw.print(&quot;Node count: &quot;);</span>
<span class="fc" id="L680">                pw.println(zkServer.getZKDatabase().getNodeCount());</span>
            }
            
<span class="fc" id="L683">        }</span>
    }
    
    private class ConsCommand extends CommandThread {
<span class="fc" id="L687">        public ConsCommand(PrintWriter pw) {</span>
<span class="fc" id="L688">            super(pw);</span>
<span class="fc" id="L689">        }</span>
        
        @SuppressWarnings(&quot;unchecked&quot;)
        @Override
        public void commandRun() {
<span class="pc bpc" id="L694" title="1 of 2 branches missed.">            if (zkServer == null) {</span>
<span class="nc" id="L695">                pw.println(ZK_NOT_SERVING);</span>
            } else {
                // clone should be faster than iteration
                // ie give up the cnxns lock faster
                HashSet&lt;NIOServerCnxn&gt; cnxns;
<span class="fc" id="L700">                synchronized (factory.cnxns) {</span>
<span class="fc" id="L701">                    cnxns = (HashSet&lt;NIOServerCnxn&gt;) factory.cnxns.clone();</span>
<span class="pc" id="L702">                }</span>
<span class="fc bfc" id="L703" title="All 2 branches covered.">                for (NIOServerCnxn c : cnxns) {</span>
<span class="fc" id="L704">                    c.dumpConnectionInfo(pw, false);</span>
<span class="fc" id="L705">                    pw.println();</span>
<span class="fc" id="L706">                }</span>
<span class="fc" id="L707">                pw.println();</span>
            }
<span class="fc" id="L709">        }</span>
    }
    
    private class WatchCommand extends CommandThread {
<span class="fc" id="L713">        int len = 0;</span>
<span class="fc" id="L714">        public WatchCommand(PrintWriter pw, int len) {</span>
<span class="fc" id="L715">            super(pw);</span>
<span class="fc" id="L716">            this.len = len;</span>
<span class="fc" id="L717">        }</span>

        @Override
        public void commandRun() {
<span class="pc bpc" id="L721" title="1 of 2 branches missed.">            if (zkServer == null) {</span>
<span class="nc" id="L722">                pw.println(ZK_NOT_SERVING);</span>
            } else {
<span class="fc" id="L724">                DataTree dt = zkServer.getZKDatabase().getDataTree();</span>
<span class="fc bfc" id="L725" title="All 2 branches covered.">                if (len == wchsCmd) {</span>
<span class="fc" id="L726">                    dt.dumpWatchesSummary(pw);</span>
<span class="fc bfc" id="L727" title="All 2 branches covered.">                } else if (len == wchpCmd) {</span>
<span class="fc" id="L728">                    dt.dumpWatches(pw, true);</span>
                } else {
<span class="fc" id="L730">                    dt.dumpWatches(pw, false);</span>
                }
<span class="fc" id="L732">                pw.println();</span>
            }
<span class="fc" id="L734">        }</span>
    }

    private class MonitorCommand extends CommandThread {

<span class="fc" id="L739">        MonitorCommand(PrintWriter pw) {</span>
<span class="fc" id="L740">            super(pw);</span>
<span class="fc" id="L741">        }</span>

        @Override
        public void commandRun() {
<span class="pc bpc" id="L745" title="1 of 2 branches missed.">            if(zkServer == null) {</span>
<span class="nc" id="L746">                pw.println(ZK_NOT_SERVING);</span>
<span class="nc" id="L747">                return;</span>
            }
<span class="fc" id="L749">            ZKDatabase zkdb = zkServer.getZKDatabase();</span>
<span class="fc" id="L750">            ServerStats stats = zkServer.serverStats();</span>

<span class="fc" id="L752">            print(&quot;version&quot;, Version.getFullVersion());</span>

<span class="fc" id="L754">            print(&quot;avg_latency&quot;, stats.getAvgLatency());</span>
<span class="fc" id="L755">            print(&quot;max_latency&quot;, stats.getMaxLatency());</span>
<span class="fc" id="L756">            print(&quot;min_latency&quot;, stats.getMinLatency());</span>

<span class="fc" id="L758">            print(&quot;packets_received&quot;, stats.getPacketsReceived());</span>
<span class="fc" id="L759">            print(&quot;packets_sent&quot;, stats.getPacketsSent());</span>
<span class="fc" id="L760">            print(&quot;num_alive_connections&quot;, stats.getNumAliveClientConnections());</span>

<span class="fc" id="L762">            print(&quot;outstanding_requests&quot;, stats.getOutstandingRequests());</span>

<span class="fc" id="L764">            print(&quot;server_state&quot;, stats.getServerState());</span>
<span class="fc" id="L765">            print(&quot;znode_count&quot;, zkdb.getNodeCount());</span>

<span class="fc" id="L767">            print(&quot;watch_count&quot;, zkdb.getDataTree().getWatchCount());</span>
<span class="fc" id="L768">            print(&quot;ephemerals_count&quot;, zkdb.getDataTree().getEphemeralsCount());</span>
<span class="fc" id="L769">            print(&quot;approximate_data_size&quot;, zkdb.getDataTree().approximateDataSize());</span>

<span class="fc" id="L771">            OSMXBean osMbean = new OSMXBean();</span>
<span class="pc bpc" id="L772" title="2 of 4 branches missed.">            if (osMbean != null &amp;&amp; osMbean.getUnix() == true) {</span>
<span class="fc" id="L773">                print(&quot;open_file_descriptor_count&quot;, osMbean.getOpenFileDescriptorCount());</span>
<span class="fc" id="L774">                print(&quot;max_file_descriptor_count&quot;, osMbean.getMaxFileDescriptorCount());</span>
            }

<span class="fc bfc" id="L777" title="All 2 branches covered.">            if(stats.getServerState().equals(&quot;leader&quot;)) {</span>
<span class="fc" id="L778">                Leader leader = ((LeaderZooKeeperServer)zkServer).getLeader();</span>

<span class="fc" id="L780">                print(&quot;followers&quot;, leader.getLearners().size());</span>
<span class="fc" id="L781">                print(&quot;synced_followers&quot;, leader.getForwardingFollowers().size());</span>
<span class="fc" id="L782">                print(&quot;pending_syncs&quot;, leader.getNumPendingSyncs());</span>
            }
<span class="fc" id="L784">        }</span>

        private void print(String key, long number) {
<span class="fc" id="L787">            print(key, &quot;&quot; + number);</span>
<span class="fc" id="L788">        }</span>

        private void print(String key, String value) {
<span class="fc" id="L791">            pw.print(&quot;zk_&quot;);</span>
<span class="fc" id="L792">            pw.print(key);</span>
<span class="fc" id="L793">            pw.print(&quot;\t&quot;);</span>
<span class="fc" id="L794">            pw.println(value);</span>
<span class="fc" id="L795">        }</span>

    }

    private class IsroCommand extends CommandThread {

<span class="fc" id="L801">        public IsroCommand(PrintWriter pw) {</span>
<span class="fc" id="L802">            super(pw);</span>
<span class="fc" id="L803">        }</span>

        @Override
        public void commandRun() {
<span class="fc bfc" id="L807" title="All 2 branches covered.">            if (zkServer == null) {</span>
<span class="fc" id="L808">                pw.print(&quot;null&quot;);</span>
<span class="fc bfc" id="L809" title="All 2 branches covered.">            } else if (zkServer instanceof ReadOnlyZooKeeperServer) {</span>
<span class="fc" id="L810">                pw.print(&quot;ro&quot;);</span>
            } else {
<span class="fc" id="L812">                pw.print(&quot;rw&quot;);</span>
            }
<span class="fc" id="L814">        }</span>
    }

    /** Return if four letter word found and responded to, otw false **/
    private boolean checkFourLetterWord(final SelectionKey k, final int len)
    throws IOException
    {
        // We take advantage of the limited size of the length to look
        // for cmds. They are all 4-bytes which fits inside of an int
<span class="fc" id="L823">        String cmd = cmd2String.get(len);</span>
<span class="fc bfc" id="L824" title="All 2 branches covered.">        if (cmd == null) {</span>
<span class="fc" id="L825">            return false;</span>
        }
<span class="fc" id="L827">        LOG.info(&quot;Processing &quot; + cmd + &quot; command from &quot;</span>
<span class="fc" id="L828">                + sock.socket().getRemoteSocketAddress());</span>
<span class="fc" id="L829">        packetReceived();</span>

        /** cancel the selection key to remove the socket handling
         * from selector. This is to prevent netcat problem wherein
         * netcat immediately closes the sending side after sending the
         * commands and still keeps the receiving channel open. 
         * The idea is to remove the selectionkey from the selector
         * so that the selector does not notice the closed read on the
         * socket channel and keep the socket alive to write the data to
         * and makes sure to close the socket after its done writing the data
         */
<span class="pc bpc" id="L840" title="1 of 2 branches missed.">        if (k != null) {</span>
            try {
<span class="fc" id="L842">                k.cancel();</span>
<span class="nc" id="L843">            } catch(Exception e) {</span>
<span class="nc" id="L844">                LOG.error(&quot;Error cancelling command selection key &quot;, e);</span>
<span class="fc" id="L845">            }</span>
        }

<span class="fc" id="L848">        final PrintWriter pwriter = new PrintWriter(</span>
                new BufferedWriter(new SendBufferWriter()));
<span class="fc bfc" id="L850" title="All 2 branches covered.">        if (len == ruokCmd) {</span>
<span class="fc" id="L851">            RuokCommand ruok = new RuokCommand(pwriter);</span>
<span class="fc" id="L852">            ruok.start();</span>
<span class="fc" id="L853">            return true;</span>
<span class="fc bfc" id="L854" title="All 2 branches covered.">        } else if (len == getTraceMaskCmd) {</span>
<span class="fc" id="L855">            TraceMaskCommand tmask = new TraceMaskCommand(pwriter);</span>
<span class="fc" id="L856">            tmask.start();</span>
<span class="fc" id="L857">            return true;</span>
<span class="fc bfc" id="L858" title="All 2 branches covered.">        } else if (len == setTraceMaskCmd) {</span>
<span class="fc" id="L859">            incomingBuffer = ByteBuffer.allocate(8);</span>
<span class="fc" id="L860">            int rc = sock.read(incomingBuffer);</span>
<span class="pc bpc" id="L861" title="1 of 2 branches missed.">            if (rc &lt; 0) {</span>
<span class="nc" id="L862">                throw new IOException(&quot;Read error&quot;);</span>
            }

<span class="fc" id="L865">            incomingBuffer.flip();</span>
<span class="fc" id="L866">            long traceMask = incomingBuffer.getLong();</span>
<span class="fc" id="L867">            ZooTrace.setTextTraceLevel(traceMask);</span>
<span class="fc" id="L868">            SetTraceMaskCommand setMask = new SetTraceMaskCommand(pwriter, traceMask);</span>
<span class="fc" id="L869">            setMask.start();</span>
<span class="fc" id="L870">            return true;</span>
<span class="fc bfc" id="L871" title="All 2 branches covered.">        } else if (len == enviCmd) {</span>
<span class="fc" id="L872">            EnvCommand env = new EnvCommand(pwriter);</span>
<span class="fc" id="L873">            env.start();</span>
<span class="fc" id="L874">            return true;</span>
<span class="fc bfc" id="L875" title="All 2 branches covered.">        } else if (len == confCmd) {</span>
<span class="fc" id="L876">            ConfCommand ccmd = new ConfCommand(pwriter);</span>
<span class="fc" id="L877">            ccmd.start();</span>
<span class="fc" id="L878">            return true;</span>
<span class="fc bfc" id="L879" title="All 2 branches covered.">        } else if (len == srstCmd) {</span>
<span class="fc" id="L880">            StatResetCommand strst = new StatResetCommand(pwriter);</span>
<span class="fc" id="L881">            strst.start();</span>
<span class="fc" id="L882">            return true;</span>
<span class="fc bfc" id="L883" title="All 2 branches covered.">        } else if (len == crstCmd) {</span>
<span class="fc" id="L884">            CnxnStatResetCommand crst = new CnxnStatResetCommand(pwriter);</span>
<span class="fc" id="L885">            crst.start();</span>
<span class="fc" id="L886">            return true;</span>
<span class="fc bfc" id="L887" title="All 2 branches covered.">        } else if (len == dumpCmd) {</span>
<span class="fc" id="L888">            DumpCommand dump = new DumpCommand(pwriter);</span>
<span class="fc" id="L889">            dump.start();</span>
<span class="fc" id="L890">            return true;</span>
<span class="fc bfc" id="L891" title="All 4 branches covered.">        } else if (len == statCmd || len == srvrCmd) {</span>
<span class="fc" id="L892">            StatCommand stat = new StatCommand(pwriter, len);</span>
<span class="fc" id="L893">            stat.start();</span>
<span class="fc" id="L894">            return true;</span>
<span class="fc bfc" id="L895" title="All 2 branches covered.">        } else if (len == consCmd) {</span>
<span class="fc" id="L896">            ConsCommand cons = new ConsCommand(pwriter);</span>
<span class="fc" id="L897">            cons.start();</span>
<span class="fc" id="L898">            return true;</span>
<span class="fc bfc" id="L899" title="All 6 branches covered.">        } else if (len == wchpCmd || len == wchcCmd || len == wchsCmd) {</span>
<span class="fc" id="L900">            WatchCommand wcmd = new WatchCommand(pwriter, len);</span>
<span class="fc" id="L901">            wcmd.start();</span>
<span class="fc" id="L902">            return true;</span>
<span class="fc bfc" id="L903" title="All 2 branches covered.">        } else if (len == mntrCmd) {</span>
<span class="fc" id="L904">            MonitorCommand mntr = new MonitorCommand(pwriter);</span>
<span class="fc" id="L905">            mntr.start();</span>
<span class="fc" id="L906">            return true;</span>
<span class="pc bpc" id="L907" title="1 of 2 branches missed.">        } else if (len == isroCmd) {</span>
<span class="fc" id="L908">            IsroCommand isro = new IsroCommand(pwriter);</span>
<span class="fc" id="L909">            isro.start();</span>
<span class="fc" id="L910">            return true;</span>
        }
<span class="nc" id="L912">        return false;</span>
    }

    /** Reads the first 4 bytes of lenBuffer, which could be true length or
     *  four letter word.
     *
     * @param k selection key
     * @return true if length read, otw false (wasn't really the length)
     * @throws IOException if buffer size exceeds maxBuffer size
     */
    private boolean readLength(SelectionKey k) throws IOException {
        // Read the length, now get the buffer
<span class="fc" id="L924">        int len = lenBuffer.getInt();</span>
<span class="fc bfc" id="L925" title="All 4 branches covered.">        if (!initialized &amp;&amp; checkFourLetterWord(sk, len)) {</span>
<span class="fc" id="L926">            return false;</span>
        }
<span class="pc bpc" id="L928" title="1 of 4 branches missed.">        if (len &lt; 0 || len &gt; BinaryInputArchive.maxBuffer) {</span>
<span class="fc" id="L929">            throw new IOException(&quot;Len error &quot; + len);</span>
        }
<span class="fc bfc" id="L931" title="All 2 branches covered.">        if (zkServer == null) {</span>
<span class="fc" id="L932">            throw new IOException(&quot;ZooKeeperServer not running&quot;);</span>
        }
<span class="fc" id="L934">        incomingBuffer = ByteBuffer.allocate(len);</span>
<span class="fc" id="L935">        return true;</span>
    }

    public long getOutstandingRequests() {
<span class="fc" id="L939">        synchronized (this) {</span>
<span class="fc" id="L940">            synchronized (this.factory) {</span>
<span class="fc" id="L941">                return outstandingRequests;</span>
<span class="nc" id="L942">            }</span>
<span class="nc" id="L943">        }</span>
    }

    /*
     * (non-Javadoc)
     *
     * @see org.apache.zookeeper.server.ServerCnxnIface#getSessionTimeout()
     */
    public int getSessionTimeout() {
<span class="fc" id="L952">        return sessionTimeout;</span>
    }

    @Override
    public String toString() {
<span class="fc" id="L957">        return &quot;NIOServerCnxn object with sock = &quot; + sock + &quot; and sk = &quot; + sk;</span>
    }

    /*
     * Close the cnxn and remove it from the factory cnxns list.
     * 
     * This function returns immediately if the cnxn is not on the cnxns list.
     */
    @Override
    public void close() {
<span class="fc" id="L967">        synchronized(factory.cnxns){</span>
            // if this is not in cnxns then it's already closed
<span class="fc bfc" id="L969" title="All 2 branches covered.">            if (!factory.cnxns.remove(this)) {</span>
<span class="fc" id="L970">                return;</span>
            }

<span class="fc" id="L973">            synchronized (factory.ipMap) {</span>
<span class="fc" id="L974">                Set&lt;NIOServerCnxn&gt; s =</span>
<span class="fc" id="L975">                    factory.ipMap.get(sock.socket().getInetAddress());</span>
<span class="fc" id="L976">                s.remove(this);</span>
<span class="pc" id="L977">            }</span>

<span class="fc" id="L979">            factory.unregisterConnection(this);</span>

<span class="fc bfc" id="L981" title="All 2 branches covered.">            if (zkServer != null) {</span>
<span class="fc" id="L982">                zkServer.removeCnxn(this);</span>
            }
    
<span class="fc" id="L985">            closeSock();</span>
    
<span class="pc bpc" id="L987" title="1 of 2 branches missed.">            if (sk != null) {</span>
                try {
                    // need to cancel this selection key from the selector
<span class="fc" id="L990">                    sk.cancel();</span>
<span class="nc" id="L991">                } catch (Exception e) {</span>
<span class="nc bnc" id="L992" title="All 2 branches missed.">                    if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L993">                        LOG.debug(&quot;ignoring exception during selectionkey cancel&quot;, e);</span>
                    }
<span class="fc" id="L995">                }</span>
            }
<span class="pc" id="L997">        }</span>
<span class="fc" id="L998">    }</span>

    /**
     * Close resources associated with the sock of this cnxn. 
     */
    private void closeSock() {
<span class="pc bpc" id="L1004" title="1 of 2 branches missed.">        if (sock.isOpen() == false) {</span>
<span class="nc" id="L1005">            return;</span>
        }

<span class="fc" id="L1008">        LOG.info(&quot;Closed socket connection for client &quot;</span>
<span class="fc bfc" id="L1009" title="All 2 branches covered.">                + sock.socket().getRemoteSocketAddress()</span>
                + (sessionId != 0 ?
<span class="fc" id="L1011">                        &quot; which had sessionid 0x&quot; + Long.toHexString(sessionId) :</span>
                        &quot; (no session established for client)&quot;));
        try {
            /*
             * The following sequence of code is stupid! You would think that
             * only sock.close() is needed, but alas, it doesn't work that way.
             * If you just do sock.close() there are cases where the socket
             * doesn't actually close...
             */
<span class="fc" id="L1020">            sock.socket().shutdownOutput();</span>
<span class="nc" id="L1021">        } catch (IOException e) {</span>
            // This is a relatively common exception that we can't avoid
<span class="nc bnc" id="L1023" title="All 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L1024">                LOG.debug(&quot;ignoring exception during output shutdown&quot;, e);</span>
            }
<span class="fc" id="L1026">        }</span>
        try {
<span class="fc" id="L1028">            sock.socket().shutdownInput();</span>
<span class="nc" id="L1029">        } catch (IOException e) {</span>
            // This is a relatively common exception that we can't avoid
<span class="nc bnc" id="L1031" title="All 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L1032">                LOG.debug(&quot;ignoring exception during input shutdown&quot;, e);</span>
            }
<span class="fc" id="L1034">        }</span>
        try {
<span class="fc" id="L1036">            sock.socket().close();</span>
<span class="nc" id="L1037">        } catch (IOException e) {</span>
<span class="nc bnc" id="L1038" title="All 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L1039">                LOG.debug(&quot;ignoring exception during socket close&quot;, e);</span>
            }
<span class="fc" id="L1041">        }</span>
        try {
<span class="fc" id="L1043">            sock.close();</span>
            // XXX The next line doesn't seem to be needed, but some posts
            // to forums suggest that it is needed. Keep in mind if errors in
            // this section arise.
            // factory.selector.wakeup();
<span class="nc" id="L1048">        } catch (IOException e) {</span>
<span class="nc bnc" id="L1049" title="All 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L1050">                LOG.debug(&quot;ignoring exception during socketchannel close&quot;, e);</span>
            }
<span class="fc" id="L1052">        }</span>
<span class="fc" id="L1053">    }</span>
    
<span class="fc" id="L1055">    private final static byte fourBytes[] = new byte[4];</span>

    /*
     * (non-Javadoc)
     *
     * @see org.apache.zookeeper.server.ServerCnxnIface#sendResponse(org.apache.zookeeper.proto.ReplyHeader,
     *      org.apache.jute.Record, java.lang.String)
     */
    @Override
    synchronized public void sendResponse(ReplyHeader h, Record r, String tag) {
        try {
<span class="fc" id="L1066">            ByteArrayOutputStream baos = new ByteArrayOutputStream();</span>
            // Make space for length
<span class="fc" id="L1068">            BinaryOutputArchive bos = BinaryOutputArchive.getArchive(baos);</span>
            try {
<span class="fc" id="L1070">                baos.write(fourBytes);</span>
<span class="fc" id="L1071">                bos.writeRecord(h, &quot;header&quot;);</span>
<span class="fc bfc" id="L1072" title="All 2 branches covered.">                if (r != null) {</span>
<span class="fc" id="L1073">                    bos.writeRecord(r, tag);</span>
                }
<span class="fc" id="L1075">                baos.close();</span>
<span class="nc" id="L1076">            } catch (IOException e) {</span>
<span class="nc" id="L1077">                LOG.error(&quot;Error serializing response&quot;);</span>
<span class="fc" id="L1078">            }</span>
<span class="fc" id="L1079">            byte b[] = baos.toByteArray();</span>
<span class="fc" id="L1080">            ByteBuffer bb = ByteBuffer.wrap(b);</span>
<span class="fc" id="L1081">            bb.putInt(b.length - 4).rewind();</span>
<span class="fc" id="L1082">            sendBuffer(bb);</span>
<span class="fc bfc" id="L1083" title="All 2 branches covered.">            if (h.getXid() &gt; 0) {</span>
<span class="fc" id="L1084">                synchronized(this){</span>
<span class="fc" id="L1085">                    outstandingRequests--;</span>
<span class="pc" id="L1086">                }</span>
                // check throttling
<span class="fc" id="L1088">                synchronized (this.factory) {        </span>
<span class="fc bfc" id="L1089" title="All 4 branches covered.">                    if (zkServer.getInProcess() &lt; outstandingLimit</span>
                            || outstandingRequests &lt; 1) {
<span class="fc" id="L1091">                        sk.selector().wakeup();</span>
<span class="fc" id="L1092">                        enableRecv();</span>
                    }
<span class="pc" id="L1094">                }</span>
            }
<span class="nc" id="L1096">         } catch(Exception e) {</span>
<span class="nc" id="L1097">            LOG.warn(&quot;Unexpected exception. Destruction averted.&quot;, e);</span>
<span class="fc" id="L1098">         }</span>
<span class="fc" id="L1099">    }</span>

    /*
     * (non-Javadoc)
     *
     * @see org.apache.zookeeper.server.ServerCnxnIface#process(org.apache.zookeeper.proto.WatcherEvent)
     */
    @Override
    synchronized public void process(WatchedEvent event) {
<span class="fc" id="L1108">        ReplyHeader h = new ReplyHeader(-1, -1L, 0);</span>
<span class="pc bpc" id="L1109" title="1 of 2 branches missed.">        if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L1110">            ZooTrace.logTraceMessage(LOG, ZooTrace.EVENT_DELIVERY_TRACE_MASK,</span>
                                     &quot;Deliver event &quot; + event + &quot; to 0x&quot;
<span class="nc" id="L1112">                                     + Long.toHexString(this.sessionId)</span>
                                     + &quot; through &quot; + this);
        }

        // Convert WatchedEvent to a type that can be sent over the wire
<span class="fc" id="L1117">        WatcherEvent e = event.getWrapper();</span>

<span class="fc" id="L1119">        sendResponse(h, e, &quot;notification&quot;);</span>
<span class="fc" id="L1120">    }</span>

    /*
     * (non-Javadoc)
     *
     * @see org.apache.zookeeper.server.ServerCnxnIface#getSessionId()
     */
    @Override
    public long getSessionId() {
<span class="fc" id="L1129">        return sessionId;</span>
    }

    @Override
    public void setSessionId(long sessionId) {
<span class="fc" id="L1134">        this.sessionId = sessionId;</span>
<span class="fc" id="L1135">    }</span>

    @Override
    public void setSessionTimeout(int sessionTimeout) {
<span class="fc" id="L1139">        this.sessionTimeout = sessionTimeout;</span>
<span class="fc" id="L1140">    }</span>

    @Override
    public int getInterestOps() {
<span class="fc bfc" id="L1144" title="All 2 branches covered.">        return sk.isValid() ? sk.interestOps() : 0;</span>
    }

    @Override
    public InetSocketAddress getRemoteSocketAddress() {
<span class="fc bfc" id="L1149" title="All 2 branches covered.">        if (sock.isOpen() == false) {</span>
<span class="fc" id="L1150">            return null;</span>
        }
<span class="fc" id="L1152">        return (InetSocketAddress) sock.socket().getRemoteSocketAddress();</span>
    }

    @Override
    protected ServerStats serverStats() {
<span class="fc bfc" id="L1157" title="All 2 branches covered.">        if (zkServer == null) {</span>
<span class="fc" id="L1158">            return null;</span>
        }
<span class="fc" id="L1160">        return zkServer.serverStats();</span>
    }

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>